package hr.pmf.abkloubcar.drd.model;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

public class Node {

    public int getIndex() {
        return index;
    }

    public int index;

    public int getCost() {
        return cost;
    }

    public void setCost(int cost) {
        this.cost = cost;
    }

    public int  cost;

    public int weight;

    public List<Node> neighbours = new ArrayList<Node>();

    public boolean dominating = false;

    public boolean dominated = false;

    public Node(int index) {
        this.index = index;
    }

    public int getDegree() {
        return this.neighbours.size();
    }

    public double getDegreeCostFactor() {
        return 1.0 * this.getDegree() / this.cost;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Node node = (Node) o;
        return index == node.index;
    }

    @Override
    public int hashCode() {
        return Objects.hash(index);
    }
}
