package hr.pmf.abkloubcar.drd.model;

import hr.pmf.abkloubcar.drd.DominatingSetSolver.*;
import hr.pmf.abkloubcar.drd.InitialWeightsSolver.*;

public class InputParameters {

    public String logLevel;

    public boolean append;

    public DominatingSetSelection dominatingSetSelection;

    public DominatingSetSort dominatingSetSort;

    public InitialWeightsVariant initialWeightsVariant;

    public boolean allCombinations;

    public InputParameters(String logLevel, boolean append, DominatingSetSelection dominatingSetSelection, DominatingSetSort dominatingSetSort, InitialWeightsVariant initialWeightsVariant, boolean allCombinations) {
        this.logLevel = logLevel;
        this.append = append;
        this.dominatingSetSelection = dominatingSetSelection;
        this.dominatingSetSort = dominatingSetSort;
        this.initialWeightsVariant = initialWeightsVariant;
        this.allCombinations = allCombinations;
    }

    public String getLogLevel() {
        return logLevel;
    }

    public void setLogLevel(String logLevel) {
        this.logLevel = logLevel;
    }

    public boolean isAppend() {
        return append;
    }

    public void setAppend(boolean append) {
        this.append = append;
    }

    public DominatingSetSelection getDominatingSetSelection() {
        return dominatingSetSelection;
    }

    public void setDominatingSetSelection(DominatingSetSelection dominatingSetSelection) {
        this.dominatingSetSelection = dominatingSetSelection;
    }

    public DominatingSetSort getDominatingSetSort() {
        return dominatingSetSort;
    }

    public void setDominatingSetSort(DominatingSetSort dominatingSetSort) {
        this.dominatingSetSort = dominatingSetSort;
    }

    public InitialWeightsVariant getInitialWeightsVariant() {
        return initialWeightsVariant;
    }

    public void setInitialWeightsVariant(InitialWeightsVariant initialWeightsVariant) {
        this.initialWeightsVariant = initialWeightsVariant;
    }

    public boolean isAllCombinations() {
        return allCombinations;
    }

    public void setAllCombinations(boolean allCombinations) {
        this.allCombinations = allCombinations;
    }

    @Override
    public String toString() {
        return "Parameters: " +
                "logLevel='" + logLevel + '\'' +
                ", append=" + append +
                ", dominatingSetSelection=" + dominatingSetSelection +
                ", dominatingSetSort=" + dominatingSetSort +
                ", initialWeightsVariant=" + initialWeightsVariant;
    }
}
